=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-01-08 00:00:26 +0000
+++ loggerhead/changecache.py	2007-05-30 08:57:43 +0000
@@ -87,32 +87,33 @@
         else:
             cache = shelve.open(self._changes_filename, 'c', protocol=2)
 
-        out = []
-        fetch_list = []
-        sfetch_list = []
-        for revid in revid_list:
-            # if the revid is in unicode, use the utf-8 encoding as the key
-            srevid = util.to_utf8(revid)
-            
-            if srevid in cache:
-                out.append(cache[srevid])
-            else:
-                #self.log.debug('Entry cache miss: %r' % (revid,))
-                out.append(None)
-                fetch_list.append(revid)
-                sfetch_list.append(srevid)
-        
-        if len(fetch_list) > 0:
-            # some revisions weren't in the cache; fetch them
-            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
-            if changes is None:
-                return changes
-            for i in xrange(len(revid_list)):
-                if out[i] is None:
-                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
-        
-        cache.close()
-        return out
+        try:
+            out = []
+            fetch_list = []
+            sfetch_list = []
+            for revid in revid_list:
+                # if the revid is in unicode, use the utf-8 encoding as the key
+                srevid = util.to_utf8(revid)
+
+                if srevid in cache:
+                    out.append(cache[srevid])
+                else:
+                    #self.log.debug('Entry cache miss: %r' % (revid,))
+                    out.append(None)
+                    fetch_list.append(revid)
+                    sfetch_list.append(srevid)
+
+            if len(fetch_list) > 0:
+                # some revisions weren't in the cache; fetch them
+                changes = self.history.get_changes_uncached(fetch_list, get_diffs)
+                if len(changes) == 0:
+                    return changes
+                for i in xrange(len(revid_list)):
+                    if out[i] is None:
+                        cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
+            return out
+        finally:
+            cache.close()
     
     @with_lock
     def full(self, get_diffs=False):

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-03-14 06:10:22 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-05-30 08:57:43 +0000
@@ -67,6 +67,9 @@
             entry_list = scan_list[:pagesize]
             entries = h.get_changes(entry_list)
         except:
+##             import sys
+##             print sys.exc_info()[2]
+##             import pdb; pdb.post_mortem(sys.exc_info()[2])
             self.log.exception('Exception fetching changes')
             raise InternalError('Could not fetch changes')
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-05-29 11:19:07 +0000
+++ loggerhead/history.py	2007-05-30 08:57:43 +0000
@@ -605,7 +605,7 @@
             changes = self.get_changes_uncached(revid_list, get_diffs)
         else:
             changes = self._change_cache.get_changes(revid_list, get_diffs)
-        if changes is None:
+        if len(changes) == 0:
             return changes
         
         # some data needs to be recalculated each time, because it may
@@ -694,6 +694,8 @@
                 # i don't know why. :(
                 self.log.debug('No such revision (skipping): %s', e)
                 revid_list.remove(e.revision)
+        if not revid_list:
+            return []
         
         delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
         combined_list = zip(rev_list, delta_list)

